; ============================================================================
;   
serial_init:       ;01010010b
    mov      SCON, #01010010b ; #11011010b
;                   X   X
; 7, 6:     
; 5:   UART,     ,      0
; 4:  , 1,   
; 3:       2, 3
; 2:       2, 3 ( )
; 1:   ,      .     
; 0:   ,     .     
;  :
; 00 -  ,  / f/12
; 01 - 8 bit UART,  /    TC1
; 10 - 9 bit UART,  / f/64 , f/32
; 11 - 9 bit UART,  /    TC1
    mov      TMOD, #00100001b    ;    T/C1 (!!!       T/C0)
; 7:       --1 (TC1)    INT1,  1
; 6:      1,  TC1      .  - 
; 5, 4:    TC1
; 3:       --0 (TC0)    INT0,  1
; 2:      1,  TC0      .  - 
; 1, 0:    TC0
    mov      TH1, #11110011b   ; 2400 bod
    setb     TR1               ;  
    ret

; ============================================================================
;        A
serial_send:
    mov      C, P                     ;     
    mov      TB8, C                   ;   SCON.3
serial_send_wait:
    jnb      TI, serial_send_wait     ;   
    clr      TI                       ;   
    mov      SBUF, A                  ;  
    lcall    count_and_inverse_hl
    ret

; ============================================================================
;        A
serial_read:
    jnb      RI, serial_read          ;   
    clr      RI                       ;   
    mov      A, SBUF                  ;      A
    mov      C, RB8                   ;     C
    lcall    count_and_inverse_hl
    ret

